'***********************************************************************
'
'    Filename        :     RPM-Count		
'    File Version    :     1.0
'    Datum           :     01.11.2007             	
'    Autor           :     Peter Verderber		
'    Funktion        :     Drehzahlmesser		
'    Letzte Revision :     1.0
'    Datum           :     01.11.2007           
'    Ziel PIC        :     16F628A	
'    Compiler        :     iL_BAS16 - Professional   
'    
'***********************************************************************
'*****                Definitionen und Konstanten                  *****
'***********************************************************************

Date
Time

$NCALDEF
         
define device 16f628a,wdt_off,hs_osc,cmcfg7,MCLR_INT,OSC2_IO,T0CS_INT     
                  
         xtal 4.00
         
         tris ra,%00000111
         tris rb,%00000000
       
         inp ra,0
         inp ra,1
         inp ra,2
         output rb,0
                  
'$DEBUG 3,ra,4
      
define Usec   = auto as word          'Umdrehungen pro Sekunde
define RPM    = auto as word          'Umdrehungen pro Minute 
define RPM1   = auto as word          'Nachkommastellen bei  
define Komma  = auto as byte          'Umfangsgeschwindigkeit
define Mode   = auto as byte          'Messverfahren
define Taste1 = ra,1                  'Taste RUN / HOLD / Ok
define Taste2 = ra,2                  'Taste Auswahl Messverfahren 
define beeper = rb,7                  'Summer           

goto main                             'Start Hauptprogramm

'***********************************************************************
'*****                   Unterprogramme                            *****
'***********************************************************************

init:                                  'LCD-Initialisierung 
  lcdinit rb,2,16,                                    
  lcdwrite 1,1," Drehzahlmesser "      'Begrungstext
  lcdwrite 2,1,"PVC - electronic"
  wait 2500
  return

menu:                                  'Auswahl Messverfahren
  if Taste2 = 0 then wait 10           'Taste2 entprellen 
  if Taste2 = 0 then inc Mode          'Taste2 (Usec) abfragen 
  if Mode   > 7 then let Mode = 1
  on Mode gosub menu_text,Usec1,Usec2,Usec3,Usec4,Usec5,Usec6,Usec7
  wait 200                             'Verzgerung zwischen Tastendruck
  if Taste1 = 0 then wait 10           'Taste1 entprellen          
  if Taste1 = 0 then goto main_loop    'Taste1 (OK) abfragen         
  goto menu                                 
  return
         
menu_text:                             'Anzeige Eingabeaufforderung
  lcdwrite 1,1," Waehlen Sie das"         
  lcdwrite 2,1," Messverfahren !"
  return

Usec1:                                 'Usec 1 Drehzahlmessung 
  lcdwrite 1,1,"U/min mechanisch"      'mit Drehgeber
  lcdwrite 2,1," mit Drehgeber  "
  return

Usec2:                                 'Usec 2 Drehzahlmessung optisch 
  lcdwrite 1,1," U/min optisch  "      'mit einer Messmarke
  lcdwrite 2,1,"mit 1 Messmarke "
  return
         
Usec3:                                 'Usec 3 Drehzahlmessung optisch 
  lcdwrite 2,1,"mit 2 Messmarken"      'mit zwei Messmarken
  return

Usec4:                                 'Usec 4 Drehzahlmessung optisch 
  lcdwrite 2,1,"mit 3 Messmarken"      'mit drei Messmarken
  return

Usec5:                                 'Usec 5 Drehzahlmessung optisch 
  lcdwrite 2,1,"mit 4 Messmarken"      'mit vier Messmarken
  return

Usec6:                                 'Usec 6 Umfangsgeschwindigkeit 
  lcdwrite 1,1,"m/min mechanisch"      'mit Drehgeber         
  lcdwrite 2,1," mit Drehgeber  "
  return

Usec7:                                 'Usec 7 Frequenzmessung
  lcdwrite 1,1,"Frequenzmessung "
  lcdwrite 2,1,"   allgemein    "
  return

titel1:                                'Anzeigetext fr laufende Anzeige
  lcdwrite 1,1,"DREHZAHL     RUN"      'Umdrehungen
  return

titel2:                                'Anzeigetext fr laufende Anzeige
  lcdwrite 1,1,"UMFANG       RUN"      'Umfangsgeschwindigkeit
  return
         
titel3:                                'Anzeigetext fr laufende Anzeige
  lcdwrite 1,1,"FREQUENZ     RUN"      'Frequenz
  return 

mess1:                                 'Messung U/min mit mech. Drehgeber
  gosub titel1                         '1 Umdrehung am Sensor = 100 Impulse 
  freqin ra,0,2400,Usec                           
  let RPM = Usec / 2                   'Umrechnung von F (Hz) auf U/min
  if RPM > 5999 then set beeper        'Warnton ein bei > 5999 U/min  
  if RPM < 6000 then res beeper        'Warnton aus bei < 6000 U/min
  return

mess2:                                 '1 Umdrehung = 1 Marke = 1 Impuls          
  gosub titel1                         'Messung Frequenz fr Umdrehungen 
  freqin ra,0,2000,Usec                'Messung U/min mit opt. Sensor
  let RPM = Usec * 60                  'Umrechnung von F (Hz) auf U/min
  return

mess3:                                 '1 Umdrehung = 2 Marken = 2 Impulse
  gosub mess2                          'Messung U/min mit opt. Sensor
  let RPM = RPM / 2                    'Umrechnung von F (Hz) auf U/min
  return

mess4:                                 '1 Umdrehung = 3 Marke = 3 Impulse
  gosub mess2                          'Messung U/min mit opt. Sensor
  let RPM = RPM / 3                    'Umrechnung von F (Hz) auf U/min
  return                                            

mess5:                                 '1 Umdrehung = 4 Marken = 4 Impulse
  gosub mess2                          'Messung U/min mit opt. Sensor
  let RPM = RPM / 4                    'Umrechnung von F (Hz) auf U/min
  return                                  

mess6:                                 'Messung der Umfangsgeschwindigkeit
  gosub titel2                         'Anzeige mit 2 Nachkommastellen     
  let komma = 1                        'fr Umfangsgeschwindigkeiten                                    
  freqin ra,0,1000,Usec                'bis ca. 260 m/min 
  if Usec > 2999 then set beeper       'Warnton ein bei > 5999 U/min 
  if Usec < 3000 then res beeper       'Warnton aus bei < 6000 U/min
  if Usec < 1310 then gosub umrechnung    
  if Usec > 1300 then gosub teiler
  return
         
teiler:
  let Komma = 0                        'Anzeige mit 1 Nachkommastelle
  let Usec = Usec / 10                 'fr Umfangsgeschwindigkeiten           
  gosub umrechnung                     'ab ca. 250 m/min
  return
         
umrechnung:                            'Berechnung der Umfangsgeschwindigkeit
  let RPM  = Usec * 48                 'Umfang Messrad 162.1 mm, d = 51.6 mm  
  let RPM1 = Usec * 63                 'eine Umdrehung pro Sekunde am Geber  
  let RPM1 = RPM1 / 100                'entsprechen 100 Impulse bzw. 100 Hz
  let RPM  = RPM + RPM1               
  let RPM  = RPM / 10 * 4              'Umrechnung von f auf m/min          
  return
         
mess7:                                 'Messung der Frequenz allgemein 
  gosub titel3                         'Fmax. ca.50 kHz   
  freqin ra,0,2000,Usec                   
  let RPM = Usec
  return

disp1:                                 'Anzeige U/min    
  lcdwrite 2,1,"n          U/min"
  lcdwrite 2,6,RPM
  return
        
disp2:                                 'Anzeige m/min
  lcdwrite 2,1,"v          m/min"         
  on Komma gosub komma1, komma2
  return
         
disp3:                                 'Anzeige Hz
  lcdwrite 2,1,"F             Hz"         
  lcdwrite 2,9,RPM
  return         
         
komma1:                                'Anzeige m/min mit 1 Kommastelle
  lcdwrite 2,5,RPM,:1
  return
         
komma2:                                'Anzeige m/min mit 2 Kommastellen
   lcdwrite 2,5,RPM,:2
   return         
          
hold:                                  'Messwertanzeige speichern
  if Mode < 6 then lcdwrite 1,1,"DREHZAHL    HOLD"
  if Mode = 6 then lcdwrite 1,1,"UMFANG      HOLD"   
  if Mode > 6 then lcdwrite 1,1,"FREQUENZ    HOLD"
  res beeper                           'Warnton aus
  wait 400
  if Taste1 = 0 then wait 10           'Taste1 entprellen
  if Taste1 = 0 then goto main_loop else goto hold
  return

'***********************************************************************
'*****                     Hauptprogramm                           *****
'***********************************************************************

main:
  gosub init                           'LCD-Initialisierung
  let Mode = 0
  gosub menu                           'Auswahl Messverfahren
         
  main_loop:                           'Schleife Messen + Anzeigen                                
  on Mode gosub mess1,mess1,mess2,mess3,mess4,mess5,mess6,mess7
  on Mode gosub disp1,disp1,disp1,disp1,disp1,disp1,disp2,disp3
         
  if Taste1 = 0 then goto hold         'Gehe zu Anzeige speichern
  if Taste2 = 0 then goto menu         'Gehe zu Menuauswahl
  goto main_loop
        
  goto main
        
  end                                  'Ende gut, alles gut       
        
        